﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security;
using System.Web;
using System.Web.Security;
using System.Web.UI;

namespace WebApplication1
{
	// *************************************************************************
	// *** WebFormLogin ********************************************************
	// *************************************************************************
	public partial class WebFormLogin : Page
	{
		// ---------------------------------------------------------------------
		private static readonly Dictionary<string, string> Uzivatelia = new Dictionary<string, string>()
		{
			{ "pitko", "heslo" },
			{ "admin", "admin" }
		};

		// ---------------------------------------------------------------------
		// --- WebFormLogin Events ---------------------------------------------
		// ---------------------------------------------------------------------
		protected void Page_Load(object sender, EventArgs e)
		{
			if (!IsPostBack)
				Logout(Context);
		}

		// ---------------------------------------------------------------------
		protected void ButtonLogin_Click(object sender, EventArgs e)
		{
			bool validnyUzivatel =
				Uzivatelia.Keys.Contains(TextBoxLoginName.Text) &&
				Uzivatelia[TextBoxLoginName.Text] == TextBoxPassword.Text;

			if (!validnyUzivatel)
				throw new SecurityException("Pristup odmietnuty!");

			FormsAuthentication.RedirectFromLoginPage(/*userName*/TextBoxLoginName.Text, /*persitant*/false);
		}

		// ---------------------------------------------------------------------
		protected void ButtonLoginRozneStranky_Click(object sender, EventArgs e)
		{
			bool validnyUzivatel =
				Uzivatelia.Keys.Contains(TextBoxLoginName.Text) &&
				Uzivatelia[TextBoxLoginName.Text] == TextBoxPassword.Text;

			if (!validnyUzivatel)
				throw new SecurityException("Pristup odmietnuty!");

			// Autorizaujeme uzivatela
			FormsAuthentication.SetAuthCookie(/*userName*/TextBoxLoginName.Text, /*persitantCookies*/false);

			// Manualne ho redirectujeme
			if (TextBoxLoginName.Text == "admin")
				Response.Redirect("WebForm2.aspx");
			else
				Response.Redirect("WebForm1.aspx");
		}

		// ---------------------------------------------------------------------
		protected void ButtonLoginManualny_Click(object sender, EventArgs e)
		{
			bool validnyUzivatel =
				Uzivatelia.Keys.Contains(TextBoxLoginName.Text) &&
				Uzivatelia[TextBoxLoginName.Text] == TextBoxPassword.Text;

			if (!validnyUzivatel)
				throw new SecurityException("Pristup odmietnuty!");

			var ticket = new FormsAuthenticationTicket(
				/*version*/3,
				TextBoxLoginName.Text,
				/*start*/DateTime.Now,
				/*expire*/DateTime.Now.AddMinutes(120),
				/*persistantCookies*/false,
				/*data*/string.Empty);

			string hash = FormsAuthentication.Encrypt(ticket);

			var authCookie = new HttpCookie(FormsAuthentication.FormsCookieName, hash);
			authCookie.Domain = FormsAuthentication.CookieDomain;

			Context.Response.Cookies.Add(authCookie);

			// Manualne ho redirectujeme
			if (TextBoxLoginName.Text == "admin")
				Response.Redirect("WebForm2.aspx");
			else
				Response.Redirect("WebForm1.aspx");
		}

		// ---------------------------------------------------------------------
		// --- WebFormLogin Methods --------------------------------------------
		// ---------------------------------------------------------------------
		public static void Logout(HttpContext context, bool restoreSession = true)
		{
			// Clear member access informations
			FormsAuthentication.SignOut();

			// FF caching issue
			var formCookie = new HttpCookie(FormsAuthentication.FormsCookieName, /*value*/string.Empty);
			formCookie.Expires = DateTime.Now.AddYears(-1);
			context.Response.Cookies.Add(formCookie);

			// Clear session
			context.Session.RemoveAll();
			context.Session.Clear();

			if (restoreSession)
			{
				context.Session.Abandon();

				// FF caching issue
				var sessionCookie = new HttpCookie("ASP.NET_SessionId", /*value*/string.Empty);
				sessionCookie.Expires = DateTime.Now.AddYears(-1);
				context.Response.Cookies.Add(sessionCookie);
			} // if
		}
	} // public partial class WebFormLogin

} // namespace WebApplication1